//объявление библиотек
#include <ArduinoJson.h>
#include <Tone32.h>
#include <WiFi.h>
#include <DNSServer.h>
#include <AsyncTCP.h>
#include "ESPAsyncWebServer.h"
#include <LiquidCrystal.h>
#include <MainModule.h>
//пины куда подключены датчики
#define button 27
#define enkoder 39
#define buzzer 16
//обявление классов
MainModule mod;

LiquidCrystal lcd(14, 13, 5, 23, 19, 18);


//переменные 1 мудля
int8_t h = 0, m = 0, s = 0;
int millis_rem = 0;

int8_t rezim = 0, eeprom_status, rezim_status, reset_timer = 0, error_rezim = 0, end_timer = 0;

IPAddress second_ip, third_ip, fourth_ip;

uint8_t members_con;

bool get_ip_status, switch_ip_status;

int ip_interval = 0;

//переменные 2 модуля
bool clean_pedal = false;
int8_t long_press = 0, on_press = 0, not_press = 0;

//переменные 3 модуля
int8_t needed_temp = 20, first_temp = 0, first_food = 0, first_water = 0;

//переменные 4 модуля
int8_t second_temp = 0, second_gas = 0, second_fire = 0, second_flood = 0;

//настройки сервера в режиме 1
void setupServerMain() {
  //настройки главной страници
  server.on("/", HTTP_GET, [](AsyncWebServerRequest * request) {
    Serial.println("/ main");
    //получение данных с 2 модуля
    if (request->hasParam("long_press") && request->hasParam("not_press") && request->hasParam("on_press")) {
      Serial.println("not:");
      Serial.println(request->getParam("not_press")->value().toInt());
      Serial.println(not_press);
      Serial.println("long:");
      Serial.println(request->getParam("long_press")->value().toInt());
      Serial.println(long_press);
      Serial.println("on:");
      Serial.println(request->getParam("on_press")->value().toInt());
      Serial.println(on_press);

      if (rezim == 3 && request->getParam("long_press")->value().toInt() != long_press) {
        error_rezim = 3;
        long_press = request->getParam("long_press")->value().toInt();
      }
      if (rezim == 3 && request->getParam("not_press")->value().toInt() != not_press) {
        error_rezim = 2;
        not_press = request->getParam("not_press")->value().toInt();
      }
      if (rezim == 6 && request->getParam("on_press")->value().toInt() != on_press) {
        error_rezim = 2;
        on_press = request->getParam("on_press")->value().toInt();
      }
    }
    //получение данных с модуля 3
    else if (request->hasParam("seсond_temp") && request->hasParam("second_gas") && request->hasParam("second_gas_status") && request->hasParam("second_fire") && request->hasParam("second_flood")) {
      second_temp = request->getParam("second_temp")->value().toInt();
      second_gas = request->getParam("second_temp")->value().toInt();
      second_fire = request->getParam("second_temp")->value().toInt();
      second_flood = request->getParam("second_flood")->value().toInt();
      if(second_fire == 1){
        rezim = 9;
      }
      if(second_flood == 1){
        rezim = 8;
      }
      if(request->getParam("second_gas_status")->value() == 0 or request->getParam("second_gas_status")->value() == "true"){
        rezim = 10;
      }
    }
    //получение данных с модуля 4
    else if (request->hasParam("first_temp") && request->hasParam("first_food") && request->hasParam("first_water")) {
      first_temp = request->getParam("first_temp")->value().toInt();
      first_food = request->getParam("first_food")->value().toInt();
      first_water = request->getParam("first_water")->value().toInt();
    }
    //получение IP адресса от других модулей
    else if (request->hasParam("module") && request->hasParam("ip1") && request->hasParam("ip2") && request->hasParam("ip3") && request->hasParam("ip4")) {
      if (request->getParam("module")->value() == "2" and second_ip.toString() == "0.0.0.0") {
        second_ip = IPAddress(request->getParam("ip1")->value().toInt(), request->getParam("ip2")->value().toInt(), request->getParam("ip3")->value().toInt(), request->getParam("ip4")->value().toInt());
        members_con ++;
      }
      if (request->getParam("module")->value() == "2" and third_ip.toString() == "0.0.0.0") {
        third_ip = IPAddress(request->getParam("ip1")->value().toInt(), request->getParam("ip2")->value().toInt(), request->getParam("ip3")->value().toInt(), request->getParam("ip4")->value().toInt());
        members_con ++;
      }
      if (request->getParam("module")->value() == "4" and fourth_ip.toString() == "0.0.0.0") {
        fourth_ip = IPAddress(request->getParam("ip1")->value().toInt(), request->getParam("ip2")->value().toInt(), request->getParam("ip3")->value().toInt(), request->getParam("ip4")->value().toInt());
        members_con ++;
      }
    }
    //возврат ответа
    String str = "{\"clean_pedal\":";
    str += clean_pedal;
    str += ",\"needed_temp\":";
    str += needed_temp;
    str += ",\"get_ip_status\":";
    str += get_ip_status;
    str += ",\"rezim\":";
    str += rezim;
    str += "}";
    request->send_P(200, "text/html", str.c_str());
  });
  //настройки страници ""all"
  server.on("/all", HTTP_GET, [](AsyncWebServerRequest * request) {
    //получение данных о очистке 2 модуля
    if (request->hasParam("clean_pedal")) {
      if (request->getParam("clean_pedal")->value() == "true" || request->getParam("clean_pedal")->value() == "1") {
        clean_pedal = true;
      }
      else if (request->getParam("clean_pedal")->value() == "false" || request->getParam("clean_pedal")->value() == "0") {
        clean_pedal = false;
      }
    }
    //создание и отправка ответа
    String str = "{\"long_press\":";
    str += long_press;
    str += ",\"press\":";
    str += on_press;
    str += ",\"not_press\":";
    str += not_press;
    str += ",\"first_temp\":";
    str += first_temp;
    str += ",\"first_food\":";
    str += first_food;
    str += "}";
    str += ",\"first_water\":";
    str += first_water;
    str += "}";
    str += ",\"second_temp\":";
    str += second_temp;
    str += ",\"second_gas\":";
    str += second_gas;
    str += ",\"second_fire\":";
    str += second_fire;
    str += ",\"second_flood\":";
    str += second_flood;
    str += ",\"members_con\":";
    str += members_con;
    str += ",\"get_ip_status\":";
    str += get_ip_status;
    str += "}";
    request->send_P(200, "text/html", str.c_str());
  });
  //настройка страници для нахожден е модуля
  server.on("/find", HTTP_GET, [](AsyncWebServerRequest * request) {
    request->send_P(200, "text/html", "Robosphera_module_1");
  });
}


void setup() {
  //инициализируем работу Serial-порта
  Serial.begin(9600);
  //инициализируем работу EEPROM
  EEPROM.begin(128);
  //инициализация экрана
  lcd.begin(16, 2);
  //чтение режимов из памяти платы
  eeprom_status = EEPROM.read(0);
  rezim_status = EEPROM.read(128);
  Serial.println(eeprom_status);
  //если режим 1 - "работа"; если нет - "настройка"
  if (eeprom_status == 1) {
    //подключение к wifi
    WiFi.mode(WIFI_STA);
    WiFi.begin(mod.getE(1, 2).c_str(), mod.getE(19, 20).c_str());

    while (WiFi.status() != WL_CONNECTED) {
      //оповещение о подлючении
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Connecting to:");
      lcd.setCursor(0, 1);
      lcd.print(mod.getE(1, 2));
      Serial.println("connecting...");
      tone(buzzer, NOTE_B2, 100, 0);
      delay(200);
      tone(buzzer, NOTE_B2, 100, 0);
      //подсчёт сколько раз не получилось подключается
      reset_timer++;
      //если не получилось подключится 60 раз
      if (reset_timer == 60) {
        tone(buzzer, NOTE_C4, 2000, 5);
        //режим "настройка" и перезагрузка
        EEPROM.write(0, 0);
        EEPROM.commit();
        ESP.restart();
      }
      delay(1000);
    }
    //оповещение о удачном подключении
    tone(buzzer, NOTE_C4, 500, 5);
    delay(100);
    noTone(buzzer, 5);
    delay(200);
    tone(buzzer, NOTE_F4, 500, 5);
    delay(100);
    noTone(buzzer, 5);
    delay(200);
    tone(buzzer, NOTE_B4, 500, 5);
    delay(100);
    noTone(buzzer, 5);
    delay(200);
    //вывод IP
    Serial.println(WiFi.localIP());
    //настройка сервера
    setupServerMain();
    server.begin();
    //инициализация портов
    pinMode(buzzer, OUTPUT);
    pinMode(enkoder, INPUT);
    pinMode(button, INPUT);
    //устанывливаем подчёт не удач на 0
    reset_timer = 0;
  }
  else {
    //создание точки доступа
    WiFi.mode(WIFI_AP);
    WiFi.softAP("Module_1", "");

    Serial.print("AP IP address: ");
    Serial.println(WiFi.softAPIP());
    //настройка сервера
    mod.setupServer();
    //оповищение о настройке
    lcd.clear();
    lcd.setCursor(3, 0);
    lcd.print("Nastroyka");
    //режим работы вадителя 0
    EEPROM.write(128, 0);
    EEPROM.commit();
  }
}

void loop() {
  //если режим 1 - "работа"; если нет - "настройка"
  if (eeprom_status == 1) {
    //если потерена связь с WiFi - переподлключение
    if (WiFi.status() != WL_CONNECTED) {
      WiFi.disconnect();
      WiFi.begin(mod.getE(1, 2).c_str(), mod.getE(19, 20).c_str());
      while (WiFi.status() != WL_CONNECTED) {
        //оповещение о переподключении
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("Reconnecting to:");
        lcd.setCursor(0, 1);
        lcd.print(mod.getE(1, 2));
        Serial.println("reconnecting...");
        tone(buzzer, NOTE_B2, 100, 0);
        delay(200);
        tone(buzzer, NOTE_B2, 100, 0);
        //подсчёт сколько раз не получилось подключается
        reset_timer++;
        //если не получилось подключится 60 раз
        if (reset_timer == 60) {
          tone(buzzer, NOTE_C4, 2000, 5);
          //режим 0 и перезагрузка
          EEPROM.write(0, 0);
          EEPROM.commit();
          ESP.restart();
        }
        delay(800);
      }
    }
    WiFiClient client;//инициализация WiFi client
    //если не получилось что-то сделать отправить или получить 60 раз
    if (reset_timer == 60) {
      //режим 0 и перезагрузка
      EEPROM.write(0, 0);
      EEPROM.commit();
      ESP.restart();
    }
    //каждые 8000 получение IP от других модулей и подсчет роботующих модулей
    if (ip_interval + 8000 < millis()) {
      if (switch_ip_status) {
        second_ip = IPAddress(0, 0, 0, 0);
        third_ip = IPAddress(0, 0, 0, 0);
        fourth_ip = IPAddress(0, 0, 0, 0);
        members_con = 0;
        get_ip_status = true;
      }
      else {
        get_ip_status = false;
      }
      switch_ip_status = !switch_ip_status;
      ip_interval = millis();
    }

    //разные режимы
    switch (rezim) {
      //старт - выбор
      case 0:
        //перезагрузка и настройка
        if (analogRead(enkoder) <= 1000) {
          delay(120);
          lcd.clear();
          lcd.setCursor(3, 0);
          lcd.print("Nastroyka");
          lcd.setCursor(1, 1);
          lcd.print("(perezagruzka)");
          if (digitalRead(button) == 0) {
            delay(100);
            EEPROM.write(0, 0);
            EEPROM.commit();
            ESP.restart();
            tone(buzzer, NOTE_B2, 100, 0);
          }
        }
        //просмотр IP
        else if (analogRead(enkoder) > 1000 and analogRead(enkoder) <= 2000) {
          delay(120);
          lcd.clear();
          lcd.setCursor(7, 0);
          lcd.print("IP");
          lcd.setCursor(4, 1);
          lcd.print("Addresses");
          if (digitalRead(button) == 0) {
            delay(100);
            rezim = 7;
            tone(buzzer, NOTE_B2, 100, 0);
          }
        }
        //выбор режима водителя - отдых
        else if (analogRead(enkoder) > 2000 and analogRead(enkoder) <= 3000) {
          delay(120);
          lcd.clear();
          lcd.setCursor(4, 0);
          lcd.print("Rezhim:");
          lcd.setCursor(5, 1);
          lcd.print("otdikh");
          if (digitalRead(button) == 0) {
            delay(100);
            //если в памяти следующий режим водителя 2(отдых) или 0(ничего)
            if (rezim_status == 2 or rezim_status == 0) {
              tone(buzzer, NOTE_B2, 100, 0);
              rezim = 4;
              s = 0;
              if (h == 0 && m < 45) {
                h = 0;
                m = 45;
              }
            }
            else {
              tone(buzzer, NOTE_B2, 100, 0);
              delay(100);
              tone(buzzer, NOTE_B2, 100, 0);
              delay(100);
              tone(buzzer, NOTE_B2, 100, 0);
            }
          }
        }
        //выбор режима водителя - работа
        else if (analogRead(enkoder) > 3000) {
          delay(120);
          lcd.clear();
          lcd.setCursor(4, 0);
          lcd.print("Rezhim:");
          lcd.setCursor(5, 1);
          lcd.print("rabota");
          if (digitalRead(button) == 0) {
            delay(100);
            //если в памяти следующий режим водителя 1(работа) или 0(ничего)
            if (rezim_status == 1 or rezim_status == 0) {
              tone(buzzer, NOTE_B2, 100, 0);
              rezim = 1;
              s = 0;
              if (h > 4 || h == 4 && m > 30) {
                h = 4;
                m = 30;
              }
            }
            else {
              tone(buzzer, NOTE_B2, 100, 0);
              delay(100);
              tone(buzzer, NOTE_B2, 100, 0);
              delay(100);
              tone(buzzer, NOTE_B2, 100, 0);
            }
          }
        }
        break;
      //настройка для работы водителя
      case 1:
        //выбор - отмена, вернутся назад
        if (analogRead(enkoder) <= 1500) {
          delay(120);
          lcd.clear();
          lcd.setCursor(5, 0);
          lcd.print("Otmena");
          lcd.setCursor(2, 1);
          lcd.print("(vernutsya)");
          if (digitalRead(button) == 0) {
            delay(100);
            tone(buzzer, NOTE_B2, 100, 0);
            rezim = 0;
          }
        }
        //выбор - установка времени работы
        else if (analogRead(enkoder) > 1500 and analogRead(enkoder) <= 3100) {
          delay(120);
          lcd.clear();
          lcd.setCursor(1, 0);
          lcd.print("Vremya raboty:");
          lcd.setCursor(5, 1);
          lcd.print((String) h + ":" + m + ":" + s);
          if (digitalRead(button) == 0) {
            delay(100);
            tone(buzzer, NOTE_B2, 100, 0);
            rezim = 2;
          }
        }
        //выбор - начать работать
        else if (analogRead(enkoder) > 3100) {
          delay(120);
          lcd.clear();
          lcd.setCursor(4, 0);
          lcd.print("Nachat");
          lcd.setCursor(4, 1);
          lcd.print("rabotat");
          if (digitalRead(button) == 0) {
            delay(100);
            if (h != 0 && m != 0) {
              tone(buzzer, NOTE_B2, 100, 0);
              rezim = 3;
              error_rezim = 0;
              end_timer = 0;
              s = 0;
              millis_rem = millis();
            }
            else {
              tone(buzzer, NOTE_B2, 100, 0);
              delay(100);
              tone(buzzer, NOTE_B2, 100, 0);
              delay(100);
              tone(buzzer, NOTE_B2, 100, 0);
            }
          }
        }
        break;
      //работа водителя : установка времяни
      case 2:
        delay(120);
        lcd.clear();
        lcd.setCursor(5, 1);
        lcd.print((String) h + ":" + m + ":" + s);
        m = (analogRead(enkoder) / 17 % 60 / 10 * 10 + 30) % 60;
        h = (analogRead(enkoder) / 17 / 60) + ((analogRead(enkoder) / 17 % 60 / 10 * 10 + 30) / 60);
        if (digitalRead(button) == 0) {
          delay(100);
          tone(buzzer, NOTE_B2, 100, 0);
          rezim = 1;
        }
        break;
      //работа водителя
      case 3:
        //подсчёт времени
        delay(100);
        if (millis() - millis_rem >= 900 && h != 0 && m != 0 && s != 0 || millis() - millis_rem >= 900 && end_timer != 10) {
          s --;
          millis_rem = millis();
        }
        if (s == -1) {
          s = 59;
          m --;
        }
        if (m == -1) {
          m = 59;
          h --;
        }
        //если время подошлу к концу или если водитель не работает, то закончить работу водителя
        if (h == 0 && m == 0 && s == 0 || end_timer == 10) {
          error_rezim = 4;
        }
        //отображение статусов
        switch (error_rezim) {
          //всё в норме
          case 0:
            //отмена, вернутся назад
            if (analogRead(enkoder) <= 1000) {
              lcd.clear();
              lcd.setCursor(5, 0);
              lcd.print("Otmena");
              lcd.setCursor(2, 1);
              lcd.print("(vernutsya)");
              if (digitalRead(button) == 0) {
                delay(100);
                tone(buzzer, NOTE_B2, 100, 0);
                rezim = 0;
              }
            }
            //просмотр 3 модуля
            else if (analogRead(enkoder) > 1000 and analogRead(enkoder) <= 2000) {
              lcd.clear();
              lcd.setCursor(0, 0);
              lcd.print((String)"Zver " + needed_temp + "\xDF" + "c:");
              lcd.setCursor(0, 1);
              String str = String(first_temp);
              str += "\xDF";
              str += "c;";
              if (first_food == 0) {
                str += "N;";
              }
              else {
                str += "Y;";
              }
              if (first_water == 0) {
                str += "N";
              }
              else {
                str += "Y";
              }
              lcd.print(str);
              if (digitalRead(button) == 0) {
                tone(buzzer, NOTE_B2, 100, 0);
                error_rezim = 1;
              }
            }
            //просмотр 4 модуля
            else if (analogRead(enkoder) > 2000 and analogRead(enkoder) <= 3000) {
              lcd.clear();
              lcd.setCursor(0, 0);
              lcd.print((String)"Gruz:");
              lcd.setCursor(0, 1);
              String str = String(second_temp);
              str += "\xDF";
              str += "c;";
              str += String(second_gas);
              str += "ppm;";
              if (second_fire == 0) {
                str += "N;";
              }
              else {
                str += "Y;";
              }
              if (second_flood == 0) {
                str += "N";
              }
              else {
                str += "Y";
              }
              lcd.print(str);

            }
            //просмотр сколько модулей подключено и время
            else if (analogRead(enkoder) > 3000) {
              lcd.clear();
              lcd.setCursor(2, 0);
              lcd.print((String)members_con + " modulya rab");
              lcd.setCursor(4, 1);
              lcd.print((String)h + ":" + m + ":" + s);
            }
            break;
          //настройка нужной температуры для 3 модуля
          case 1:
            lcd.clear();
            lcd.setCursor(6, 0);
            needed_temp = analogRead(enkoder) / 91 - 15;
            lcd.print(needed_temp);
            if (digitalRead(button) == 0) {
              tone(buzzer, NOTE_B2, 100, 0);
              error_rezim = 0;
            }
            break;
          //человек дольго не нажимал на педаль
          case 2:
            lcd.clear();
            lcd.setCursor(1, 0);
            lcd.print("Vy rabotayete?");
            //если "да" то подсчёт сколько раз водитель сказал "да", нет то выйти в меню выбора режима водителя
            if (analogRead(enkoder) > 2000) {
              lcd.setCursor(6, 1);
              lcd.print("Da");
              if (digitalRead(button) == 0) {
                tone(buzzer, NOTE_B2, 100, 0);
                error_rezim = 0;
                end_timer ++;
              }
            }
            else {
              lcd.setCursor(6, 1);
              lcd.print("Net");
              if (digitalRead(button) == 0) {
                tone(buzzer, NOTE_B2, 100, 0);
                rezim = 0;
              }
            }
            tone(buzzer, NOTE_B2, 100, 0);
            break;
          //водитель много и долго нажимает на педаль
          case 3:
            lcd.clear();
            lcd.setCursor(2, 0);
            lcd.print("Ne speshite!");
            lcd.setCursor(6, 1);
            lcd.print("Ok");
            if (digitalRead(button) == 0) {
              tone(buzzer, NOTE_B2, 100, 0);
              error_rezim = 0;
              end_timer ++;
            }
            tone(buzzer, NOTE_B2, 100, 0);
            break;
          //конец работы водителя
          case 4:
            EEPROM.write(128, 2);
            EEPROM.commit();
            rezim_status = EEPROM.read(128);
            lcd.clear();
            lcd.setCursor(1, 0);
            lcd.print("Pora");
            lcd.setCursor(1, 1);
            lcd.print("otdikhat!");
            if (digitalRead(button) == 0) {
              tone(buzzer, NOTE_B2, 100, 0);
              rezim = 4;
            }
            tone(buzzer, NOTE_B2, 250, 0);
            break;
        }
        break;
      //настройка для работы водителянастройка для работы водителя
      case 4:
      //выбор - отмена, вернытся назад
        if (analogRead(enkoder) <= 1500) {
          delay(120);
          lcd.clear();
          lcd.setCursor(5, 0);
          lcd.print("Otmena");
          lcd.setCursor(2, 1);
          lcd.print("(vernutsya)");
          if (digitalRead(button) == 0) {
            delay(100);
            tone(buzzer, NOTE_B2, 100, 0);
            rezim = 0;
          }
        }
        //выбор - установка времени для отдыха водителя
        else if (analogRead(enkoder) > 1500 and analogRead(enkoder) <= 3100) {
          delay(120);
          lcd.clear();
          lcd.setCursor(1, 0);
          lcd.print("Vremya otdikha:");
          lcd.setCursor(5, 1);
          lcd.print((String) h + ":" + m + ":" + s);
          if (digitalRead(button) == 0) {
            delay(100);
            tone(buzzer, NOTE_B2, 100, 0);
            rezim = 5;
          }
        }
        //выбор - начать работать
        else if (analogRead(enkoder) > 3100) {
          delay(120);
          lcd.clear();
          lcd.setCursor(4, 0);
          lcd.print("Nachat");
          lcd.setCursor(4, 1);
          lcd.print("Otdihat");
          if (digitalRead(button) == 0) {
            if (h != 0 && m != 0) {
              tone(buzzer, NOTE_B2, 100, 0);
              rezim = 6;
              error_rezim = 0;
              end_timer = 0;
              s = 0;
              millis_rem = millis();
            }
            else {
              tone(buzzer, NOTE_B2, 100, 0);
              delay(100);
              tone(buzzer, NOTE_B2, 100, 0);
              delay(100);
              tone(buzzer, NOTE_B2, 100, 0);
            }
          }
        }
        break;
      //отдых выдителя - установка времени
      case 5:
        delay(120);
        lcd.clear();
        lcd.setCursor(5, 1);
        lcd.print((String) h + ":" + m + ":" + s);
        if (analogRead(enkoder) <= 2000) {
          m = (analogRead(enkoder) / 8 % 60 / 15 * 15 + 45) % 60;
          h = (analogRead(enkoder) / 8 / 60) + ((analogRead(enkoder) / 8 % 60 / 15 * 15 + 45) / 60);
        }
        else {
          m = 0;
          h = analogRead(enkoder) / 6.5 / 60;
        }
        if (digitalRead(button) == 0) {
          delay(100);
          tone(buzzer, NOTE_B2, 100, 0);
          rezim = 4;
        }
        break;
      //отдых водителя
      case 6:
      //подсчёт времени
        delay(100);
        if (millis() - millis_rem >= 900 && h != 0 && m != 0 && s != 0 || millis() - millis_rem >= 900 && end_timer != 10) {
          s --;
          millis_rem = millis();
        }
        if (s == -1) {
          s = 59;
          m --;
        }
        if (m == -1) {
          m = 59;
          h --;
        }
        //если время подошлу к концу или если водитель не работает, то закончить работу водителя
        if (h == 0 && m == 0 && s == 0 || end_timer == 10) {
          error_rezim = 4;
        }
        //отображение статусов
        switch (error_rezim) {
          //всё в норме//всё в норме
          case 0:
          //отмена, вернутся назад
            if (analogRead(enkoder) <= 1000) {
              lcd.clear();
              lcd.setCursor(5, 0);
              lcd.print("Otmena");
              lcd.setCursor(2, 1);
              lcd.print("(vernutsya)");
              if (digitalRead(button) == 0) {
                delay(100);
                tone(buzzer, NOTE_B2, 100, 0);
                rezim = 0;
              }
            }
            //просмотр 3 модуля
            else if (analogRead(enkoder) > 1000 and analogRead(enkoder) <= 2000) {
              lcd.clear();
              lcd.setCursor(0, 0);
              lcd.print((String)"Zver " + needed_temp + "\xDF" + "c:");
              lcd.setCursor(0, 1);
              String str = String(first_temp);
              str += "\xDF";
              str += "c;";
              if (first_food == 0) {
                str += "N;";
              }
              else {
                str += "Y;";
              }
              if (first_water == 0) {
                str += "N";
              }
              else {
                str += "Y";
              }
              lcd.print(str);
              if (digitalRead(button) == 0) {
                tone(buzzer, NOTE_B2, 100, 0);
                error_rezim = 1;
              }
            }
            //просмотр 4 модуля
            else if (analogRead(enkoder) > 2000 and analogRead(enkoder) <= 3000) {
              lcd.clear();
              lcd.setCursor(0, 0);
              lcd.print((String)"Gruz:");
              lcd.setCursor(0, 1);
              String str = String(second_temp);
              str += "\xDF";
              str += "c;";
              str += String(second_gas);
              str += "ppm;";
              if (second_fire == 0) {
                str += "N;";
              }
              else {
                str += "Y;";
              }
              if (second_flood == 0) {
                str += "N";
              }
              else {
                str += "Y";
              }
              lcd.print(str);

            }
            //просмотр сколько модулей подключено и время
            else if (analogRead(enkoder) > 3000) {
              lcd.clear();
              lcd.setCursor(2, 0);
              lcd.print((String)members_con + " modulya rab");
              lcd.setCursor(4, 1);
              lcd.print((String)h + ":" + m + ":" + s);
            }
            break;
          //настройка нужной температуры для 3 модуля
          case 1:
            lcd.clear();
            lcd.setCursor(6, 0);
            needed_temp = analogRead(enkoder) / 91 - 15;
            lcd.print(needed_temp);
            if (digitalRead(button) == 0) {
              tone(buzzer, NOTE_B2, 100, 0);
              error_rezim = 0;
            }
            break;
            //человек нажимает на педаль
          case 2:
            lcd.clear();
            lcd.setCursor(1, 0);
            lcd.print("Vy otdykhayete?");
            //если "да" то подсчёт сколько раз водитель сказал "да", нет то выйти в меню выбора режима водителя
            if (analogRead(enkoder) > 2000) {
              lcd.setCursor(6, 1);
              lcd.print("Da");
              if (digitalRead(button) == 0) {
                tone(buzzer, NOTE_B2, 100, 0);
                error_rezim = 0;
                end_timer ++;
              }
            }
            else {
              lcd.setCursor(6, 1);
              lcd.print("Net");
              if (digitalRead(button) == 0) {
                tone(buzzer, NOTE_B2, 100, 0);
                rezim = 0;
              }
            }
            tone(buzzer, NOTE_B2, 100, 0);
            break;
            //окончание отдыха водителя
          case 4:
            EEPROM.write(128, 1);
            EEPROM.commit();
            rezim_status = EEPROM.read(128);
            lcd.clear();
            lcd.setCursor(1, 0);
            lcd.print("Pora");
            lcd.setCursor(1, 1);
            lcd.print("rabotat!");
            if (digitalRead(button) == 0) {
              tone(buzzer, NOTE_B2, 100, 0);
              rezim = 1;
            }
            tone(buzzer, NOTE_B2, 250, 0);
            break;
        }

        break;
        //вывод IP модулей
      case 7:
        if (analogRead(enkoder) <= 1000) {
          delay(120);
          lcd.clear();
          lcd.setCursor(0, 0);
          lcd.print("Module 1");
          lcd.setCursor(0, 1);
          lcd.print(WiFi.localIP());
          if (digitalRead(button) == 0) {
            tone(buzzer, NOTE_B2, 100, 0);
            rezim = 0;
          }
        }
        else if (analogRead(enkoder) > 1000 and analogRead(enkoder) <= 2000) {
          delay(120);
          lcd.clear();
          lcd.setCursor(0, 0);
          lcd.print("Module 2");
          lcd.setCursor(0, 1);
          if (String(second_ip) == "0.0.0.0") {
            lcd.print("-");
          }
          else {
            lcd.print(second_ip);
          }
          if (digitalRead(button) == 0) {
            tone(buzzer, NOTE_B2, 100, 0);
            rezim = 0;
          }
        }
        else if (analogRead(enkoder) > 2000 and analogRead(enkoder) <= 3000) {
          delay(120);
          lcd.clear();
          lcd.setCursor(0, 0);
          lcd.print("Module 3");
          lcd.setCursor(0, 1);
          if (String(third_ip) == "0.0.0.0") {
            lcd.print("-");
          }
          else {
            lcd.print(third_ip);
          }
          if (digitalRead(button) == 0) {
            tone(buzzer, NOTE_B2, 100, 0);
            rezim = 0;
          }
        }
        else if (analogRead(enkoder) > 3000) {
          delay(120);
          lcd.clear();
          lcd.setCursor(0, 0);
          lcd.print("Module 4");
          lcd.setCursor(0, 1);
          if (String(fourth_ip) == "0.0.0.0") {
            lcd.print("-");
          }
          else {
            lcd.print(fourth_ip);
          }
          if (digitalRead(button) == 0) {
            tone(buzzer, NOTE_B2, 100, 0);
            rezim = 0;
          }
        }
        break;
      //оповещение о протечке
      case 8:
        delay(120);
        lcd.clear();
        lcd.setCursor(3, 0);
        lcd.print("VNIMANIE!");
        lcd.setCursor(4, 1);
        lcd.print("Potop!");
        if (digitalRead(button) == 0) {
          tone(buzzer, NOTE_B2, 100, 0);
          rezim = 0;
        }
        tone(buzzer, NOTE_B2, 100, 0);
        break;
        //оповещение о пожаре
      case 9:
        delay(120);
        lcd.clear();
        lcd.setCursor(3, 0);
        lcd.print("VNIMANIE!");
        lcd.setCursor(4, 1);
        lcd.print("Pozhar!");
        if (digitalRead(button) == 0) {
          tone(buzzer, NOTE_B2, 100, 0);
          rezim = 0;
        }
        tone(buzzer, NOTE_B2, 100, 0);
        break;
        //оповещение об утечке газа
      case 10:
        delay(120);
        lcd.clear();
        lcd.setCursor(3, 0);
        lcd.print("VNIMANIE!");
        lcd.setCursor(1, 1);
        lcd.print("Utechka gaza!");
        if (digitalRead(button) == 0) {
          tone(buzzer, NOTE_B2, 100, 0);
          rezim = 0;
        }
        tone(buzzer, NOTE_B2, 100, 0);
        break;

    }
  }
  else {
    //работа dns сервера
    dnsServer.processNextRequest();
  }
}
